<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <base-searchbar
      :filter-by="filterList"
      :filter-count="1"
      title="Authors"
      icon="mdi-account-group"
      show-add-filter
      @trigger="$trigger"
      @refresh="bootstrap"
    >
      <template v-slot:body>
        <v-btn
          color="primary"
          @click="modals.createAuthor.status = true"
        >
          <v-icon>mdi-plus</v-icon>
        </v-btn>
      </template>
    </base-searchbar>

    <v-card>
      <v-data-table
        :headers="archiveTableHeader"
        :items="publishedAuthorsList"
        class="elevation-1"
        :loading="dataStatus.authorsTable.loading"
      >
        <template v-slot:item.archives="{ item }">
          <v-chip
            v-for="i in item.archives"
            :key="i.id"
            class="ma-1 green lighten-5"
            label
            small
          >
            {{ i.title | $truncateString(20) }}
          </v-chip>
        </template>

        <template v-slot:item.subjects="{ item }">
          <v-chip
            v-for="i in item.subjects"
            :key="i.id"
            class="ma-1 red lighten-5"
            label
            small
            v-text="i.sub"
          />
        </template>

        <template v-slot:item.actions="{ item }">
          <v-btn
            small
            class="mr-1"
            color="primary"
            @click="handleClickModifyAuthor({ item })"
          >
            Edit
          </v-btn>

          <v-btn
            v-if="!item.author_deleted_at"
            small
            color="red white--text"
            @click="handleClickDeleteAuthor({ item })"
          >
            Delete
          </v-btn>

          <v-btn
            v-if="item.author_deleted_at"
            small
            color="blue"
            @click="handleClickRestoreAuthor({ item })"
          >
            Restore
          </v-btn>
        </template>
      </v-data-table>
    </v-card>

    <!-- create author -->
    <base-modal
      v-model="modals.createAuthor.status"
      title="create author"
      @trigger="handleTriggerCreateAuthor"
    >
      <template #body>
        <v-text-field
          v-model="modals.createAuthor.data.author"
          label="Author*"
          outlined
          required
        />
      </template>
    </base-modal>

    <!-- modify author -->
    <base-modal
      v-model="modals.modifyAuthor.status"
      title="modify author"
      @trigger="handleTriggerModifyAuthor"
    >
      <template #body>
        <v-text-field
          v-model="modals.modifyAuthor.data.author"
          label="Author*"
          outlined
          required
        />
      </template>
    </base-modal>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import _get from 'lodash/get'

export default {
  name: 'Authors',

  data: () => ({
    filterList: ['Author', 'Archive', 'Subject'],

    archiveTableHeader: [
      { text: 'ID', value: 'author_id', width: 100 },
      { text: 'Name', value: 'name', width: 200 },
      { text: 'Archives', value: 'archives', width: 400 },
      { text: 'Subjects', value: 'subjects' },
      { text: 'Actions', value: 'actions', width: 200 }
    ],

    dataStatus: {
      authorsTable: { loading: true }
    },

    modals: {
      createAuthor: {
        status: false,
        data: {
          author: ''
        },
        reset () {
          this.data.author = ''
        }
      },
      modifyAuthor: {
        status: false,
        data: {
          id: '',
          author: ''
        },
        reset () {
          this.data.id = ''
          this.data.author = ''
        }
      }
    }
  }),

  computed: {
    ...mapState('authors', {
      authorsList: 'authors',
      publishedAuthorsList: 'publishedAuthors'
    })
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  methods: {
    ...mapActions('authors', {
      getPublishedAuthorsList: 'getPublishedAuthorsList',
      createAuthor: 'createAuthor',
      modifyAuthor: 'modifyAuthor',
      deleteAuthor: 'deleteAuthor',
      restoreAuthor: 'restoreAuthor'
    }),

    bootstrap (params) {
      const config = {
        loading: 'dataStatus.authorsTable.loading'
      }

      this.statusWrapper(async () => {
        await this.getPublishedAuthorsList({ ...this.$route.query, ...params })
      }, config)
    },

    async handleTriggerCreateAuthor () {
      const modal = this.modals.createAuthor

      try {
        await this.createAuthor(modal.data)
        await this.bootstrap()

        this.$setAlert({ type: 'success' })

        modal.status = false
        modal.reset()
      } catch (error) {
        const message = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text: message })
        throw new Error(error)
      }
    },

    handleClickModifyAuthor ({ item }) {
      const modal = this.modals.modifyAuthor

      modal.data.id = item.author_id
      modal.data.author = item.name
      modal.status = true
    },

    async handleTriggerModifyAuthor () {
      const modal = this.modals.modifyAuthor

      try {
        await this.modifyAuthor(modal.data)
        await this.bootstrap()

        this.$setAlert({ type: 'success' })

        modal.status = false
        modal.reset()
      } catch (error) {
        this.$handleError(error)
      }
    },

    handleClickDeleteAuthor ({ item }) {
      const success = async () => {
        try {
          await this.deleteAuthor({ author_id: item.author_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    },

    handleClickRestoreAuthor ({ item }) {
      const success = async () => {
        try {
          await this.restoreAuthor({ author_id: item.author_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    }

  }
}
</script>
